void automaton(int subproblem, int size, int row, int column, int pebbles, int &top, int &right, int &bottom, int &left)
{
    bool odd = size % 2 == 1;
    bool even = size % 2 == 0;
    int middle = (size + 1) / 2;

    if (subproblem == 1) // A + B
    {
        if (row < size)
            bottom = pebbles;
        if (row == size && column < size)
            right = pebbles;
    }

    if (subproblem == 2) // |A - B|
    {
        if (odd)
        {
            if (row == 1 && column < middle)
            {
                right = 1;
            }
            if (row == 1 && column == middle)
            {
                if (pebbles % 2 == 1)
                    bottom = 1;
            }
            if (row == 1 && column > middle)
            {
                left = 1;
            }
            if (row > 1 && row < size)
            {
                bottom = pebbles;
            }
            if (row == size && column < size)
            {
                right = pebbles;
            }
        }

        if (even)
        {
            if (row == 1 && column < middle && column != 2)
            {
                right = 1;
            }
            if (row == 1 && column == 2)
            {
                if (pebbles > 1)
                    right = 1;
            }
            if (row == 1 && column == middle)
            {
                if (pebbles % 2 == 1)
                    bottom = 1;
            }
            if (row == 1 && column > middle && column < size)
            {
                left = 1;
            }
            if (row == 1 && column == size)
            {
                if (pebbles > 1)
                    left = 1;
            }
            if (row > 1 && row < size)
            {
                bottom = pebbles;
            }
            if (row == size && column < size)
            {
                right = pebbles;
            }
        }
    }

    if (subproblem == 3 || subproblem == 4) // min(A, B), max(A, B)
    {
        if (odd)
        {
            if (row == 1 && column < middle)
            {
                right = 1;
            }
            if (row == 1 && column == middle)
            {
                bottom = pebbles;
            }
            if (row == 1 && column > middle)
            {
                left = 1;
            }
            if (row == 2 && column == middle)
            {
                if (pebbles == 2 || subproblem == 3) // min(A, B)
                    left = 1;
                if (pebbles == 2 || subproblem == 4) // max(A, B)
                    bottom = 1;
            }
            if (row > 2 && row < size)
            {
                bottom = pebbles;
            }
            if (row == size && column < size)
            {
                right = pebbles;
            }
        }

        if (even)
        {
            if (row == 1 && column < middle && column != 2)
            {
                right = 1;
            }
            if (row == 1 && column == 2)
            {
                if (pebbles > 1)
                    right = 1;
            }
            if (row == 1 && column == middle)
            {
                bottom = pebbles;
            }
            if (row == 1 && column > middle && column < size)
            {
                left = 1;
            }
            if (row == 1 && column == size)
            {
                if (pebbles > 1)
                    left = 1;
                if (pebbles == 1)
                    bottom = 1;
            }
            if (row == 2 && column == middle)
            {
                if (pebbles == 2 || subproblem == 3) // min(A, B)
                    left = 1;
                if (pebbles == 2 || subproblem == 4) // max(A, B)
                    bottom = 1;
            }
            if (row == 2 && column == size)
            {
                bottom = 1;
            }
            if (row > 2 && row < size)
            {
                bottom = pebbles;
            }
            if (row == size && column < size)
            {
                right = pebbles;
            }
        }
    }

    if (subproblem == 5) // (0, 1)/(1, 0)/(0, 0)
    {
        if (odd)
        {
            if (row == 1 && column == 1)
            {
                if (pebbles > 2)
                    right = 1;
                if (pebbles == 2)
                    bottom = 2;
            }
            if (row == 1 && column == size)
            {
                if (pebbles > 2)
                    left = 1;
                if (pebbles == 2)
                    bottom = 2;
            }
            if (row == 2 && column < middle)
            {
                right = pebbles;
            }
            if (row == 2 && column == middle)
            {
                if (pebbles < 3)
                    bottom = pebbles;
                if (pebbles == 3)
                    right = pebbles;
            }
            if (row == 2 && column > middle && column < size)
            {
                if (pebbles == 1)
                    left = 1;
                if (pebbles == 3)
                    right = 3;
            }
            if (row == 2 && column == size)
            {
                if (pebbles == 2)
                    left = bottom = 1;
                if (pebbles == 3)
                    bottom = 3;
            }
            if (row > 2 && row < size && (column == middle || column == size))
            {
                bottom = pebbles;
            }
            if (row == size && column == 1)
            {
                if (pebbles == 2)
                    top = 2;
            }
            if (row == size && column > 1 && column < middle)
            {
                left = pebbles;
            }
            if (row == size && column == middle)
            {
                if (pebbles == 2)
                    left = 1;
                if (pebbles == 3)
                {
                    left = 1;
                    right = 2;
                }
            }
            if (row == size && column > middle && column < size)
            {
                if (pebbles == 2)
                    right = 2;
            }
            if (row == size && column == size)
            {
                if (pebbles > 1)
                    left = pebbles;
            }
        }

        if (even)
        {
            //    :
            if (row == 1 && column == 1)
            {
                right = pebbles;
            }
            if (row == 1 && column == 2)
            {
                bottom = pebbles;
            }
            if (row == 1 && column == size)
            {
                if (pebbles % 2 == 1)
                    bottom = pebbles;
                if (pebbles % 2 == 0)
                    bottom = 1;
            }
            if (row == 2 && column == 1)
            {
                bottom = pebbles;
            }
            if (row == 2 && column == 2)
            {
                left = pebbles;
            }
            if (row == 2 && column == size - 1)
            {
                if (pebbles > 1)
                    bottom = pebbles;
            }
            if (row == 2 && column == size)
            {
                if (pebbles % 2 == 0)
                    left = pebbles;
                if (pebbles % 2 == 1 && pebbles > 1)
                    left = 1;
            }

            //  :
            if (row == 3 && column == 1)
            {
                if (pebbles > 2)
                    right = 1;
                if (pebbles == 2)
                    bottom = 2;
            }
            if (row == 3 && column == size - 1)
            {
                if (pebbles > 2)
                    left = 1;
                if (pebbles == 2)
                    bottom = 2;
            }
            if (row == 4 && column < middle)
            {
                right = pebbles;
            }
            if (row == 4 && column == middle)
            {
                if (pebbles < 3)
                    bottom = pebbles;
                if (pebbles == 3)
                    right = pebbles;
            }
            if (row == 4 && column > middle && column < size - 1)
            {
                if (pebbles == 1)
                    left = 1;
                if (pebbles == 3)
                    right = 3;
            }
            if (row == 4 && column == size - 1)
            {
                if (pebbles == 2)
                    left = right = 1;
                if (pebbles == 3)
                    right = 3;
            }
            if (row == 4 && column == size)
            {
                bottom = pebbles;
            }
            if (row > 4 && row < size && (column == middle || column == size))
            {
                bottom = pebbles;
            }
            if (row == size && column == 1)
            {
                if (pebbles == 2)
                    top = 2;
            }
            if (row == size && column > 1 && column < middle)
            {
                left = pebbles;
            }
            if (row == size && column == middle)
            {
                if (pebbles == 2)
                    left = 1;
                if (pebbles == 3)
                {
                    left = 1;
                    right = 2;
                }
            }
            if (row == size && column > middle && column < size)
            {
                if (pebbles == 2)
                    right = 2;
            }
            if (row == size && column == size)
            {
                if (pebbles > 1)
                    left = pebbles;
            }
        }
    }
}
